Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
DL_PublicKeyImpl< GP > Class Template Reference

Discrete Log (DL) public key base implementation. More...

Inheritance diagram for DL_PublicKeyImpl< GP >:

## Public Types
typedef GP::Element | Element
Public Types inherited from DL_PublicKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< X509PublicKey, GP >
typedef GP | GroupParameters

## Public Member Functions
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters. More...
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters. More...
const DL_FixedBasePrecomputation< Element > & | GetPublicPrecomputation () const
| Accesses the public precomputation. More...
DL_FixedBasePrecomputation< Element > & | AccessPublicPrecomputation ()
| Accesses the public precomputation. More...
bool | operator== (const DL_PublicKeyImpl< GP > &rhs) const
Public Member Functions inherited from DL_PublicKey< GP::Element >
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key. More...
virtual const Element & | GetPublicElement () const
| Retrieves the public element. More...
virtual void | SetPublicElement (const Element &y)
| Sets the public element. More...
virtual Element | ExponentiatePublicElement (const Integer &exponent) const
| Exponentiates this element. More...
virtual Element | CascadeExponentiateBaseAndPublicElement (const Integer &baseExp, const Integer &publicExp) const
| Exponentiates an element. More...
Public Member Functions inherited from DL_KeyImpl< X509PublicKey, GP >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()
Public Member Functions inherited from X509PublicKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
virtual void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)=0
| Decode subjectPublicKey part of subjectPublicKeyInfo. More...
virtual void | DEREncodePublicKey (BufferedTransformation &bt) const =0
| Encode subjectPublicKey part of subjectPublicKeyInfo. More...
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

### template<class GP>
class DL_PublicKeyImpl< GP >

Discrete Log (DL) public key base implementation.

Template Parameters

  GP | GroupParameters class

Definition at line 1335 of file pubkey.h.

## Member Function Documentation

## ◆ Validate()

template<class GP >

bool DL_PublicKeyImpl< GP >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| inline virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Definition at line 1343 of file pubkey.h.

## ◆ GetVoidValue()

template<class GP >

bool DL_PublicKeyImpl< GP >::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| inline virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Definition at line 1352 of file pubkey.h.

## ◆ AssignFrom()

template<class GP >

void DL_PublicKeyImpl< GP >::AssignFrom | ( | const NameValuePairs & | source | ) |
| inline virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 1357 of file pubkey.h.

## ◆ SupportsPrecomputation()

template<class GP >

bool DL_PublicKeyImpl< GP >::SupportsPrecomputation | ( |  | ) | const
| inline virtual

Determines whether the object supports precomputation.

Returns
  true if the object supports precomputation, false otherwise

See also
  Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1362 of file pubkey.h.

## ◆ Precompute()

template<class GP >

void DL_PublicKeyImpl< GP >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) |
| inline virtual

Perform precomputation.

Parameters

  precomputationStorage | the suggested number of objects for the precompute table

Exceptions

  NotImplemented |

The exact semantics of Precompute() varies, but it typically means calculate a table of n objects that can be used later to speed up computation.

If a derived class does not override Precompute(), then the base class throws NotImplemented.

See also
  SupportsPrecomputation(), LoadPrecomputation(), SavePrecomputation()

Reimplemented from CryptoMaterial.

Definition at line 1364 of file pubkey.h.

## ◆ LoadPrecomputation()

template<class GP >

void DL_PublicKeyImpl< GP >::LoadPrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) |
| inline virtual

Retrieve previously saved precomputation.

Parameters

  storedPrecomputation | BufferedTransformation with the saved precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1370 of file pubkey.h.

## ◆ SavePrecomputation()

template<class GP >

void DL_PublicKeyImpl< GP >::SavePrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) | const
| inline virtual

Save precomputation for later use.

Parameters

  storedPrecomputation | BufferedTransformation to write the precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1376 of file pubkey.h.

## ◆ GetAbstractGroupParameters()

template<class GP >

const DL_GroupParameters<Element>& DL_PublicKeyImpl< GP >::GetAbstractGroupParameters | ( |  | ) | const
| inline virtual

Retrieves abstract group parameters.

Returns
  a const reference to the group parameters

Implements DL_Key< T >.

Definition at line 1383 of file pubkey.h.

## ◆ AccessAbstractGroupParameters()

template<class GP >

DL_GroupParameters<Element>& DL_PublicKeyImpl< GP >::AccessAbstractGroupParameters | ( |  | ) |
| inline virtual

Retrieves abstract group parameters.

Returns
  a non-const reference to the group parameters

Implements DL_Key< T >.

Definition at line 1384 of file pubkey.h.

## ◆ GetPublicPrecomputation()

template<class GP >

const DL_FixedBasePrecomputation<Element>& DL_PublicKeyImpl< GP >::GetPublicPrecomputation | ( |  | ) | const
| inline virtual

Accesses the public precomputation.

GetPublicPrecomputation returns a const reference, while AccessPublicPrecomputation returns a non-const reference. Must be overridden in derived classes.

Implements DL_PublicKey< GP::Element >.

Definition at line 1387 of file pubkey.h.

## ◆ AccessPublicPrecomputation()

template<class GP >

DL_FixedBasePrecomputation<Element>& DL_PublicKeyImpl< GP >::AccessPublicPrecomputation | ( |  | ) |
| inline virtual

Accesses the public precomputation.

GetPublicPrecomputation returns a const reference, while AccessPublicPrecomputation returns a non-const reference. Must be overridden in derived classes.

Implements DL_PublicKey< GP::Element >.

Definition at line 1388 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h